// EXPERIMENTAL
public class BarrelHilighterFilter implements PixelFilter, ParameterizedFilter {
	private final BooleanFilterParam clipNegativesParam =
		new BooleanFilterParam("Clip Negatives", true);
	
	private final FilterParam[] params = new FilterParam[] {
		clipNegativesParam
	};
	
	// ### FILTER ###
	
	public int filter(int pixel) {
		int delta = Pixels.getRed(pixel) - Pixels.getGreen(pixel);
		int normalizedDelta = clipNegativesParam.getValue()
			? ((delta < 0) ? 0 : delta)
			: (128 + delta/2);
		return Pixels.packPixel(
			Pixels.getAlpha(pixel),			// alpha
			normalizedDelta,				// red
			normalizedDelta,				// green
			normalizedDelta);				// blue
	}
	
	public String toString() {
		return "Object Hilighter (Barrel: Orange = Red-Green)";
	}
	
	// ### PARAMETERIZED FILTER ###
	
	public FilterParam[] getParams() {
		return params;
	}
}